package com.qmth.distributed.print.business.bean.result.statistics;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.distributed.print.business.enums.CardTypeEnum;
import com.qmth.teachcloud.common.annotation.ExcelProperty;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Objects;

/**
 * @Description: 扫描任务统计 result
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2024/7/11
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ScanCountResult implements Serializable {

    @ApiModelProperty(value = "主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @ApiModelProperty(value = "课程名称（代码）")
    @ExcelProperty(name = "课程（代码）", width = 20, index = 2)
    private String courseNameCode;

    @ApiModelProperty(value = "课程名称")
    private String courseName;

    @ApiModelProperty(value = "课程代码")
    private String courseCode;

    @ApiModelProperty(value = "试卷编号")
    @ExcelProperty(name = "试卷编号", width = 20, index = 3)
    private String paperNumber;

    @ApiModelProperty(value = "题卡id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long cardId;

    @ApiModelProperty(value = "开课学院")
    @ExcelProperty(name = "开课学院", width = 20, index = 1)
    private String college;

    @ApiModelProperty(value = "考生数")
    @ExcelProperty(name = "考生数", width = 20, index = 5)
    private int studentCount;

    @ApiModelProperty(value = "已扫张数")
    @ExcelProperty(name = "已扫张数", width = 20, index = 6)
    private int sheetCount;

    @ApiModelProperty(value = "缺考数")
    @ExcelProperty(name = "缺考数", width = 20, index = 7)
    private int absentCount;

    @ApiModelProperty(value = "扫描进度")
    private int scanUploadRate;

    @ApiModelProperty(value = "题卡类型")
    private CardTypeEnum cardType;

    @ApiModelProperty(value = "题卡类型str")
    @ExcelProperty(name = "题卡类型", width = 20, index = 4)
    private String cardTypeStr;

    @ApiModelProperty(value = "扫描进度str")
    @ExcelProperty(name = "扫描进度", width = 40, index = 8)
    private String scanUploadRateStr;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getCourseNameCode() {
        return courseName + "(" + courseCode + ")";
    }

    public void setCourseNameCode(String courseNameCode) {
        this.courseNameCode = courseNameCode;
    }

    public String getPaperNumber() {
        return paperNumber;
    }

    public void setPaperNumber(String paperNumber) {
        this.paperNumber = paperNumber;
    }

    public Long getCardId() {
        return cardId;
    }

    public void setCardId(Long cardId) {
        this.cardId = cardId;
    }

    public String getCollege() {
        return college;
    }

    public void setCollege(String college) {
        this.college = college;
    }

    public int getStudentCount() {
        return studentCount;
    }

    public void setStudentCount(int studentCount) {
        this.studentCount = studentCount;
    }

    public int getSheetCount() {
        return sheetCount;
    }

    public void setSheetCount(int sheetCount) {
        this.sheetCount = sheetCount;
    }

    public int getAbsentCount() {
        return absentCount;
    }

    public void setAbsentCount(int absentCount) {
        this.absentCount = absentCount;
    }

    public int getScanUploadRate() {
        return scanUploadRate;
    }

    public void setScanUploadRate(int scanUploadRate) {
        this.scanUploadRate = scanUploadRate;
    }

    public CardTypeEnum getCardType() {
        return cardType;
    }

    public void setCardType(CardTypeEnum cardType) {
        this.cardType = cardType;
    }

    public String getCardTypeStr() {
        return Objects.nonNull(cardType) ? cardType.getName() : cardTypeStr;
    }

    public void setCardTypeStr(String cardTypeStr) {
        this.cardTypeStr = cardTypeStr;
    }

    public String getScanUploadRateStr() {
        return scanUploadRate + "%";
    }

    public void setScanUploadRateStr(String scanUploadRateStr) {
        this.scanUploadRateStr = scanUploadRateStr;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }
}
